<template>
  <div>
    <div
      class="row"
      :class="isNew ? 'mb10' : 'mb30'"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="getValueFromPath(dataSource, 'eventData.occurredAt') || new Date()"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="getValueFromPath(dataSource, 'eventData.authorTitle') || userName"
          :readonly="true"
        />
      </div>
    </div>
    <template v-if="isNew">
      <ObSelect
          label="Адрес точки"
          pre-icon="pin"
          placeholder="Выберите из списка"
          :value="formData.visitPointUuid"
          :items="availablePoints"
          display-exp="address"
          class="mb30"
          @selected="onSelectPoint"
      />
    </template>
    <template v-else>
      <ObInput
          label="Адрес точки"
          :value="getValueFromPath(formData, 'specialParameters.visitPointData.addressTitle')"
          pre-icon="pin"
          :readonly="true"
      />
    </template>
    <template v-if="selectedPoint && isNew">
      <div class="row mb10">
        <div class="col-xs-6">
          <ObInput
            label="Новый тариф Клиента"
            :value="getValueFromPath(formData, keys.clientPriceWithVat)"
            type="money:2"
            sub-title="₽"
            :readonly="!isNew"
            @input="onChangeTariff({
              key: 'newClientTariff.priceWithVat',
              value: $event,
              role: 'Client'
            })"
          />
        </div>
        <div class="col-xs-6">
          <ObInput
            label="Сумма НДС"
            :value="getValueFromPath(formData, keys.clientVatPrice)"
            type="money:2"
            sub-title="₽"
            :readonly="true"
          />
        </div>
      </div>
      <div
        v-if="isNew"
        class="tariff-info"
      >
        {{ isNew ? 'Текущий' : 'Старый' }} тариф {{ oldClientTariff / 100 | currency({ dot: 2 }) }} ₽
      </div>
      <div
        v-if="suborderData.contractorUuid"
        class="row mb10 mt10"
      >
        <div class="col-xs-6">
          <ObInput
            label="Новый тариф Перевозчика"
            :value="getValueFromPath(formData, keys.carrierPriceWithVat)"
            type="money:2"
            sub-title="₽"
            :readonly="!isNew"
            @input="onChangeTariff({
              key: 'newCarrierTariff.priceWithVat',
              value: $event,
              role: 'Carrier'
            })"
          />
        </div>
        <div class="col-xs-6">
          <ObInput
            label="Сумма НДС"
            :value="getValueFromPath(formData, keys.carrierVatPrice)"
            type="money:2"
            sub-title="₽"
            :readonly="true"
          />
        </div>
      </div>
      <div
        v-if="isNew && suborderData.contractorUuid"
        class="tariff-info mb30"
      >
        {{ isNew ? 'Текущий' : 'Старый' }} тариф {{ oldCarrierTariff / 100 | currency({ dot: 2 }) }} ₽
      </div>
    </template>
    <div
      v-if="isNew || isEditMode || getValueFromPath(formData, keys.comment)"
      class="row"
    >
      <div class="col-xs-12">
        <ObTextarea
          :value="getValueFromPath(formData, keys.comment)"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField(keys.comment, $event)"
        />
      </div>
    </div>
    <template v-if="!currentFiles.length && isEditMode && !isNewForm">
      <div class="group-title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="currentFiles.length || isNew || isNewForm">
      <div class="group-title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
    <ObModal
      ref="confirmModal"
      title="Удаление точки"
      size="small"
      ok-text="Да, удалить"
      cancel-text="Нет, не удалять"
      :is-show-controls="true"
      :is-error="true"
      @submit="submitForm"
    >
      <p>Точка «{{ selectedPoint && selectedPoint.address  }}» будет удалена.</p>
      <p>Вы уверены, что хотите удалить точку?</p>
    </ObModal>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObModal from 'common-components/src/obComponents/obModal'
import { getValueFromPath } from 'common-components/src/helpers/common'
import { mapGetters } from 'vuex'

export default {
  name: 'RemovePointEventForm',
  components: {
    ObModal,
    ObInput,
    ObSelect,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor,
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
  },
  data () {
    return {
      selectedPoint: null,
      selectedAddress: null,
      suborderData: {}
    }
  },
  watch: {
    dataSource: {
      immediate: true,
      handler (dataSource) {
        const { subOrders } = dataSource
        const isOneSuborder = subOrders.length === 1
        const isTariff = isOneSuborder && subOrders[0].contractorUuid

        if (isTariff) {
          this.getSuborderData(subOrders[0])
        }

        this.selectedPoint = null
        this.selectedAddress = null
        this.suborderData = {}
      }
    },
    currentFiles (value) {
      if (!value || !value.length) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    ...mapGetters({
      userName: 'user/fullName'
    }),
    keys () {
      return {
        visitPointUuid: this.isNew ? 'visitPointUuid' : 'specialParameters.visitPointUuid',
        clientPriceWithVat: this.isNew ? 'newClientTariff.priceWithVat' : 'specialParameters.newClientTariff.priceWithVat',
        clientVatPrice: this.isNew ? 'newClientTariff.vatPrice' : 'specialParameters.newClientTariff.vatPrice',
        carrierPriceWithVat: this.isNew ? 'newCarrierTariff.priceWithVat' : 'specialParameters.newCarrierTariff.priceWithVat',
        carrierVatPrice: this.isNew ? 'newCarrierTariff.vatPrice' : 'specialParameters.newCarrierTariff.vatPrice',
        comment: this.isNew ? 'comment' : 'eventData.comment',
        fileUuids: this.isNew ? 'fileUuids' : 'eventData.fileUuids'
      }
    },
    isConfirmable () {
      return true
    },
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource?.filesData || []
    },
    isConsignor () {
      return this.selectedPoint?.type === 'FROM'
    },
    contractorTypeWordRoot () {
      return this.isConsignor
        ? 'рузоотправител'
        : 'рузополучател'
    },
    currentPointType () {
      if (this.isNew) {
        return this.selectedPoint?.type === 'FROM' ? 'CONSIGNOR' : 'CONSIGNEE'
      } else {
        return this.formData.specialParameters?.newVisitPointData?.consigneeOrConsignor
      }
    },
    availablePoints () {
      let typesExclude = []
      const list = this.order.brif?.visitPoints || []

      if (list.filter(item => item.type === 'FROM').length === 1) {
        typesExclude.push('FROM')
      }

      if (list.filter(item => item.type === 'TO').length === 1) {
        typesExclude.push('TO')
      }


      return list.filter(item => !item.hasReachedByTrip && typesExclude.every(type => type !== item.type))
    },
    oldClientTariff () {
      return this.order.actualTariff?.orderCost?.priceWithVat || this.order.totalPrice
    },
    oldCarrierTariff () {
      return this.suborderData.totalPrice
    }
  },
  methods: {
    getValueFromPath (data, path) {
      return getValueFromPath({ data, path })
    },
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField(this.keys.fileUuids, null)
        return
      }

      this.onChangeField(this.keys.fileUuids, data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    async getSuborderData (data) {
      this.suborderData = await api.orderProcess.getSubOrder({
        data,
        orderUuid: this.order.uuid,
        isClient: false
      })
    },
    onSelectContractor (item) {
      this.onChangeField('newVisitPointData.consigneeOrConsignorUuid', item.uuid)
    },
    onSelectPoint (point) {
      this.selectedPoint = point

      this.onChangeField('visitPointUuid', point.uuid)
      this.onChangeField('newClientTariff.priceWithoutVat', this.order.totalPriceWithoutVat || this.order.totalPrice)
      this.onChangeField('newClientTariff.vatPrice', this.order.vatValue)
      this.onChangeField('newClientTariff.vatRate', this.order.orderTotalAmount?.vatRate || 0)
      this.onChangeField('newClientTariff.priceWithVat', this.order.totalPrice)

      this.onChangeField('oldCarrierTariff.priceWithoutVat', this.suborderData.totalPriceWithoutVat || this.suborderData.totalPrice)
      this.onChangeField('oldCarrierTariff.vatPrice', this.suborderData.totalVat)
      this.onChangeField('oldCarrierTariff.vatRate', this.suborderData.orderTotalAmount?.vatRate || 0)
      this.onChangeField('oldCarrierTariff.priceWithVat', this.suborderData.totalPrice)

      this.onChangeField('newCarrierTariff.priceWithoutVat', this.suborderData.totalPriceWithoutVat || this.suborderData.totalPrice)
      this.onChangeField('newCarrierTariff.vatPrice', this.suborderData.totalVat)
      this.onChangeField('newCarrierTariff.vatRate', this.suborderData.orderTotalAmount?.vatRate || 0)
      this.onChangeField('newCarrierTariff.priceWithVat', this.suborderData.totalPrice)

      this.selectedAddress = null
    },
    onChangeTariff ({ key, value, role }) {
      const priceWithoutVat = this.calcPriceWithoutVat(value, this.formData['new' + role + 'Tariff'].vatRate)
      const vatPrice = value - priceWithoutVat

      this.onChangeField('new' + role + 'Tariff.vatPrice', vatPrice)
      this.onChangeField('new' + role + 'Tariff.priceWithoutVat', priceWithoutVat)
      this.onChangeField(key, value)
    },
    calcPriceWithoutVat (price, vatRate) {
      return Math.round(price / ((100 + vatRate) / 100))
    },
    showConfirmModal () {
      this.$refs.confirmModal.open()
    },
    submitForm () {
      this.$refs.confirmModal.close()
      this.$emit('submit-form')
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.row-input {
  margin-right: 0;
  margin-left: 0;
  flex-wrap: nowrap;
  &__item {
    width: 212px;
    flex-grow: 2;
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
  &__counter {
    width: 135px;
  }
}

.mb10 {
  margin-bottom: 10px!important;
}

.mt10 {
  margin-top: 10px!important;
}

.mb30 {
  margin-bottom: 30px!important;
}

.mt0 {
  margin-top: 0!important;
}

.radio-block {
  display: flex;
  align-items: center;
  margin-bottom: 15px;
  &::v-deep {
    .ob-radio-container {
      & + .ob-radio-container {
        margin-left: 25px;
      }
    }
  }
}

.tariff-info {
  @include font-mixin(14px, 18px, 400, $color-grey-label);
}

.block-inn {
  margin-bottom: 30px;
  margin-top: 10px;
  span {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    &:first-child {
      margin-right: 7px;
      color: $color-grey-label;
    }
  }
}
</style>